package phonebook;

public class PhoneBook {
	
  private Contact head;
  private String name;

  /**
   * Create a new phonebook with given name
   */
  public PhoneBook(String name) {  
  	this.name = name;    
  }

  /**
   * Return the phonebook name
   */
  public String getName() {
    return name;
  }

  /**
   * Insert a new contact at the end
   */  
  public void add(String first, String last, String number){
  	Contact c = new Contact(first, last, number);
  	if(head==null){
  		head=c;
  		return;
  	}
	Contact tmp = head;
	for(;tmp.next!=null;tmp=tmp.next){}
  	tmp.next = c;
  }

  /**
   * Return the first contact
   */  
  public String first() {
    return head.toString();
  }

  /**
   * Return the i-th contact (supposing that first 
   * index is 1)
   */
  public String get(int i) {
  	Contact c = head;
	if(c==null) return null;
  	for(int index=1; index<i; ++index){
  		c = c.next;
  		if(c==null) return null;
  	}
	return c.toString();
  }

  /**
   * Return a string containing the list of textual 
   * representation of all contacts, separated by  ", ".
   * List starts with "("and ends with ")" 
   */
  public String toString() {
  	Contact c = head;
  	String result = "(";
  	while(c!=null){
  		result += c.toString();
		c = c.next;
  		if(c!=null) result += ", ";
  	}
  	result += ")";
  	return result;
  }

  /**
   * Return the textual representation of first
   * contact containing "needle"
   */
  public String find(String needle) {
	Contact c = head;
	while(c!=null){
		if(c.contains(needle)) 
				return c.toString();
		c = c.next;
	}
	return null;
  }
  
}
